/* Legge da riga di comando due interi, n e q, e genera
   un array (allocato  nello heap)
   di n interi ciascuno compreso fra 0 e q-1, a
   caso. Dopo averlo generato lo stampa. */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void stampa_array(int *a, int n) {
  printf("[ ");
  for (int i = 0; i < n; i++) printf("%d ", a[i]);
  printf("]\n");
}

void riempi_array(int *a, int n, int q) {
  for (int i = 0; i < n; i++) a[i] = rand() % q;
}

void selection_sort(int *a, int n) {
  int i, j, minv, mini, temp;
  // i - elementi gialli (cioè la parte iniziale già ordinata)
  for (i = 0; i < n; i++) {
    // Cerco nella parte bianca (da i in avanti) il minimo
    minv = a[i];  // Valore minimo
    mini = i;     // Indice a cui l'ho trovato
    for (j = i + 1; j < n; j++)
      if (a[j] < minv) {
        minv = a[j];
        mini = j;
      }
    // Scambio il minimo (in pos. mini) con i
    temp = a[mini]; a[mini] = a[i]; a[i] = temp;
    // In Go sarebbe a[mini], a[i] = a[i], a[mini]
  }
}

int main(int argc, char **argv) {
  srand(time(NULL));
  // argv[i] è il nostro caro vecchio os.Args[i]
  int n, q;
  n = atoi(argv[1]);
  q = atoi(argv[2]);

  int *a;
  a = (int *)malloc(n * sizeof(int));
  riempi_array(a, n, q);
  stampa_array(a, n);
  printf("\nAdesso lo ordino!\n");
  selection_sort(a, n);
  stampa_array(a, n);

  free(a);

  return 0;
}
